# mypy-boto3-appmesh

[![PyPI - mypy-boto3-appmesh](https://img.shields.io/pypi/v/mypy-boto3-appmesh.svg?color=blue)](https://pypi.org/project/mypy-boto3-appmesh)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-appmesh.svg?color=blue)](https://pypi.org/project/mypy-boto3-appmesh)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-appmesh](#mypy-boto3-appmesh)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.AppMesh 1.13.25](https://boto3.amazonaws.com/v1/documentation/api/1.13.25/reference/services/appmesh.html#AppMesh) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-appmesh](#mypy-boto3-appmesh)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `AppMesh` service.

```bash
python -m pip install boto3-stubs[appmesh]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_appmesh` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_appmesh import AppMeshClient

# Now mypy can check if your code is valid.
client: AppMeshClient = boto3.client("appmesh")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AppMeshClient = session.client("appmesh")



# Annotated paginators are included as well

import mypy_boto3_appmesh.paginator as appmesh_paginators

list_meshes_paginator: appmesh_paginators.ListMeshesPaginator = client.get_paginator("list_meshes")
list_routes_paginator: appmesh_paginators.ListRoutesPaginator = client.get_paginator("list_routes")
list_tags_for_resource_paginator: appmesh_paginators.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
list_virtual_nodes_paginator: appmesh_paginators.ListVirtualNodesPaginator = client.get_paginator("list_virtual_nodes")
list_virtual_routers_paginator: appmesh_paginators.ListVirtualRoutersPaginator = client.get_paginator("list_virtual_routers")
list_virtual_services_paginator: appmesh_paginators.ListVirtualServicesPaginator = client.get_paginator("list_virtual_services")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_appmesh` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_appmesh as appmesh
from mypy_boto3_appmesh import AppMeshClient

# with these
from mypy_boto3 import appmesh
from mypy_boto3.appmesh import AppMeshClient
```